/**
 * 
 */
package org.gcube.accounting.datamodel.implementations.aggregated;

import org.gcube.accounting.datamodel.RawUsageRecord;
import org.gcube.accounting.datamodel.annotations.NotEmpty;
import org.gcube.accounting.datamodel.annotations.ValidInteger;
import org.gcube.accounting.datamodel.annotations.ValidLong;
import org.gcube.accounting.exception.InvalidValueException;

/**
 * @author Luca Frosini (ISTI - CNR) http://www.lucafrosini.com/
 */
public class StorageStatusUsageRecord extends RawUsageRecord {

	/**
	 * Generated Serial Version UID
	 */
	private static final long serialVersionUID = 2456314684466092685L;

	@NotEmpty
	public static final String PROVIDER_ID = "providerId";
	@NotEmpty
	public static final String QUALIFIER = "qualifier";
	@NotEmpty
	public static final String DATA_TYPE = "dataType";
	@ValidLong
	public static final String DATA_VOLUME = "dataVolume";
	@ValidInteger
	public static final String DATA_COUNT = "dataCount";
	
	public StorageStatusUsageRecord(){
		super();
	}
	
	public String getProviderId() {
		return (String) this.resourceSpecificProperties.get(PROVIDER_ID);
	}

	public void setProviderId(String providerId) throws InvalidValueException {
		setResourceSpecificProperty(PROVIDER_ID, providerId);
	}
	
	public String getQualifier() {
		return (String) this.resourceSpecificProperties.get(QUALIFIER);
	}

	public void setQualifier(String qualifier) throws InvalidValueException {
		setResourceSpecificProperty(QUALIFIER, qualifier);
	}
	
	public String getDataType() {
		return (String) this.resourceSpecificProperties.get(DATA_TYPE);
	}

	public void setDataType(String dataType) throws InvalidValueException {
		setResourceSpecificProperty(DATA_TYPE, dataType);
	}
	
	public long getDataVolume() {
		return (Long) this.resourceSpecificProperties.get(DATA_VOLUME);
	}

	public void setDataVolume(long dataVolume) throws InvalidValueException {
		setResourceSpecificProperty(DATA_VOLUME, dataVolume);
	}	
	
	public int getDataCount() {
		return (Integer) this.resourceSpecificProperties.get(DATA_COUNT);
	}

	public void setDataCount(int dataCount) throws InvalidValueException {
		setResourceSpecificProperty(DATA_COUNT, dataCount);
	}
	
}
