package org.gcube.accounting.datamodel.validators;

import java.io.Serializable;

import org.gcube.accounting.datamodel.annotations.ValidLong;
import org.gcube.accounting.exception.InvalidValueException;


public class ValidIntegerValidator implements FieldValidator<ValidLong>{

	public Class<ValidLong> annotation() {
		return ValidLong.class;
	}

	public boolean isValid(Serializable toValidate) {
		try {
			validate(toValidate);
		} catch (InvalidValueException e) {
			return false;
		}
		return true;
	}
	
	public Serializable validate(Serializable toValidate) throws InvalidValueException {
		if(toValidate instanceof Integer){
			return toValidate;
		}
		Integer integerObj = Integer.getInteger((String) toValidate);
		if(integerObj!=null){
			return integerObj;
		}
		
		throw new InvalidValueException(getErrorSuffix());
	}

	public String getErrorSuffix() {
		return String.format("not instace of %s", Integer.class.getSimpleName());
	}

}
